REFORM ; reform/asm
 @KBD	EQU	2BH
 @DSP	EQU	33H
 @EXIT	EQU	402DH
 @ABORT	EQU	4030H
 @ERROR	EQU	4409H
 @SELECT	EQU	4754H
 @SEEK	EQU	475EH
 @WRSEC	EQU	4763H
 @WRSYS	EQU	4768H
 @WRCYL	EQU	476DH
 @VERSEC	EQU	4772H
 @RDSEC	EQU	4777H
 @CKDRV	EQU	4290H
 @DISPLY	EQU	4467H
 @GETDCT	EQU	478FH
 @DCTBYT	EQU	479CH
 @KEYIN	EQU	40H
 @DELAY	EQU	60H
 @DIRCYL	EQU	4B64H
 @RDSSEC	EQU	4B45H
 	ORG	5200H
 ENTRY	PUSH	HL
 	LD	HL,HELLO
 	CALL	@DISPLY
 	POP	HL
 SCAN	CALL	POSHL
 	JR	C,ASKDRIVE
 	CP	'?'
 	JR	NZ,CNTSCN
 	PUSH	HL
 	LD	HL,WHO
 	CALL	@DISPLY
 	POP	HL
 	INC	HL
 	JR	SCAN
 CNTSCN	CP	':'
 	JR	NZ,HAVDRV
 	INC	HL
 HAVDRV	LD	A,(HL)
 	SUB	30H
 	JR	C,PARAMERR
 	CP	8
 	JR	NC,PARAMERR
 	LD	(DRIVE),A
 	JP	CONTINUE
 ERROR	PUSH	AF
 	CALL	SYSMOUNT
 	POP	AF
 	OR	0C0H
 	CALL	@ERROR
 	JP	@ABORT
 DRAIN	CALL	@KBD
 	OR	A
 	JR	NZ,DRAIN
 TERMIN	LD	HL,ABMSG
 ABORT	CALL	@DISPLY
 	CALL	SYSMOUNT
 	JP	@ABORT
 PARAMERR	LD	HL,PARMSG
 	CALL	@DISPLY
 ASKDRIVE	LD	HL,DRVMSG
 	CALL	@DISPLY
 	LD	B,1
 	LD	HL,STRING
 	CALL	@KEYIN
 	JR	C,TERMIN
 	JR	SCAN
 	INC	HL
 POSHL	LD	A,(HL)
 	CP	13
 	SCF
 	RET	Z
 	CP	1
 	SCF
 	RET	Z
 	CP	20H
 	JR	Z,POSHL-1
 	CP	','
 	JR	Z,POSHL-1
 	OR	A
 	RET
 CONTINUE	INC	HL
 	CALL	POSHL
 	JR	C,CONSKIP
 	CALL	UCASE
 	CP	'Y'
 	JR	Z,CONGO
 	CP	'N'
 	JR	NZ,CONSKIP
 CONGO	LD	(FLAGK),A
 	LD	A,1
 	LD	(FLAGC),A
 CONSKIP	CALL	DESMOUNT
 	LD	A,(DRIVE)
 	LD	C,A
 	CALL	@CKDRV
 	LD	A,11H
 	CALL	NZ,BADRD
 	JR	NZ,CONSKIP
 	LD	A,9
 DRIVE	EQU	$-1
 	LD	C,A
 	CALL	@GETDCT
 	BIT	3,(IY+3)
 	JR	Z,CONT0
 	LD	HL,HARDMSG
 	JP	ABORT
 CONT0	BIT	5,(IY+3)
 	JR	Z,CONT1
 	LD	HL,MSG8
 	JP	ABORT
 CONT1	LD	A,(DRIVE)
 	ADD	A,30H
 	LD	(MX1),A
 	LD	A,'8'
 	BIT	5,(IY+3)
 	JR	NZ,CONT2
 	LD	A,'5'
 CONT2	LD	(MX2),A
 	LD	A,(IY+6)
 	INC	A
 	LD	(TRACKS),A
 	CALL	ASCII
 	LD	(MX3),A
 	LD	(MX3+1),BC
 	LD	A,'D'
 	BIT	6,(IY+3)
 	JR	NZ,CONT3
 	LD	A,'S'
 CONT3	LD	(MX4),A
 	LD	A,'2'
 	BIT	5,(IY+4)
 	JR	NZ,CONT4
 	LD	A,'1'
 CONT4	LD	(MX5),A
 	LD	A,(IY+4)
 	AND	0FH
 	ADD	A,30H
 	LD	(MX2B),A
 	LD	H,'5'
 	LD	L,'.'
 	BIT	2,(IY+3)
 	JR	NZ,CCNR1
 	LD	H,'1'
 	LD	L,20H
 CCNR1	LD	(MX5C),HL
 	LD	HL,SPDTBL
 	LD	A,(IY+3)
 	AND	3
 	SLA	A
 	LD	C,A
 	LD	B,0
 	ADD	HL,BC
 	LD	DE,MX5B
 	LD	BC,2
 	LDIR
 	LD	HL,MX0
 	CALL	@DISPLY
 	CALL	COMPDATA
 	JR	NC,CONT98
 	LD	HL,NOTMEM
 	JP	ABORT
 CONT98	LD	A,(DRIVE)
 	LD	C,A
 	LD	D,0
 	CALL	@SEEK
 	JP	NZ,ERROR
 CONT5	LD	HL,PAUMSG
 	CALL	@DISPLY
 	LD	A,0C9H
 	LD	(BADRD+4),A
 	LD	(BADWRT+4),A
 	LD	(BADCYL+4),A
 	LD	HL,(4020H)
 	LD	A,0
 FLAGC	EQU	$-1
 	OR	A
 	LD	A,0
 FLAGK	EQU	$-1
 	JR	Z,FLAGH
 	LD	(HL),A
 	PUSH	IY
 	PUSH	AF
 	LD	A,10
 	CALL	@DSP
 	POP	AF
 	POP	IY
 	JR	FLAGG
 FLAGH	LD	B,3
 	LD	HL,STRING
 	CALL	@KEYIN
 	JP	C,TERMIN
 	LD	A,(HL)
 FLAGG	CALL	UCASE
 	CP	'N'
 	JR	Z,CONT6
 	CP	'Y'
 	JR	NZ,CONT5
 	XOR	A
 	LD	(BADRD+4),A
 	LD	(BADWRT+4),A
 	LD	(BADCYL+4),A
 CONT6	XOR	A
 	LD	(TRACK),A
 LOOPER	CALL	RDTRAK
 	CALL	FMTRAK
 	CALL	WRTRAK
 	LD	A,(3840H)
 	AND	4
 	JP	NZ,DRAIN
 	LD	A,0
 TRACK	EQU	$-1
 	INC	A
 	LD	(TRACK),A
 	CP	0
 TRACKS	EQU	$-1
 	JR	C,LOOPER
 	LD	HL,UPDMSG
 	CALL	@DISPLY
 	LD	A,(IY+9)
 	LD	(TRACK),A
 	CALL	RDTRAK
 	LD	HL,@WRSYS
 	LD	(WRCALL),HL
 	CALL	WRTRAK
 	LD	HL,FINMSG
 	CALL	@DISPLY
 	CALL	SYSMOUNT
 	JP	@EXIT
 RDTRAK	LD	HL,@BUFFER
 	LD	A,(DRIVE)
 	LD	C,A
 	LD	A,(TRACK)
 	LD	D,A
 	LD	E,0
 RDTLP	PUSH	BC
 	PUSH	DE
 	LD	A,D
 	CALL	ASCII
 	LD	(RDTK),A
 	LD	(RDTK+1),BC
 	LD	A,E
 	CALL	ASCII
 	LD	(RDSC),A
 	LD	(RDSC+1),BC
 	LD	A,'0'
 	BIT	4,(IY+3)
 	JR	Z,CONTR
 	INC	A
 CONTR	LD	(RDSD),A
 	PUSH	HL
 	LD	HL,RDMSG
 	CALL	@DISPLY
 	POP	HL
 	POP	DE
 	POP	BC
 	PUSH	HL
 	CALL	@RDSEC
 	POP	HL
 	CALL	NZ,BADRD
 	JR	NZ,RDTLP
 	INC	H
 	INC	E
 	LD	A,E
 	CP	0
 RDTOP	EQU	$-1
 	JR	NZ,RDTLP
 	LD	(FMTBUFF),HL
 	RET
 FMTRAK	RES	4,(IY+3)
 	XOR	A
 	LD	(SIDE),A
 	CALL	SHOFMT
 	CALL	BUILD
 	LD	A,(TRACK)
 	LD	D,A
 	LD	A,(DRIVE)
 	LD	C,A
 	LD	HL,0
 FMTBUFF	EQU	$-2
 	CALL	@WRCYL
 	CALL	NZ,BADCYL
 	JR	NZ,FMTRAK
 	BIT	5,(IY+4)
 	RET	Z
 CYLMORE	SET	4,(IY+3)
 	LD	A,1
 	LD	(SIDE),A
 	CALL	SHOFMT
 	CALL	BUILD
 	LD	A,(TRACK)
 	LD	D,A
 	LD	A,(DRIVE)
 	LD	C,A
 	LD	HL,(FMTBUFF)
 	CALL	@WRCYL
 	CALL	NZ,BADCYL
 	JR	NZ,CYLMORE
 	RET
 SHOFMT	PUSH	HL
 	PUSH	DE
 	PUSH	BC
 	LD	A,(SIDE)
 	ADD	A,30H
 	LD	(FMSD),A
 	LD	A,(TRACK)
 	CALL	ASCII
 	LD	(FMTK),A
 	LD	(FMTK+1),BC
 	LD	HL,FMMSG
 	CALL	@DISPLY
 	POP	BC
 	POP	DE
 	POP	HL
 	RET
 WRTRAK	LD	HL,@BUFFER
 	LD	A,(DRIVE)
 	LD	C,A
 	LD	A,(TRACK)
 	LD	D,A
 	LD	E,0
 WRTLP	PUSH	BC
 	PUSH	DE
 	LD	A,D
 	CALL	ASCII
 	LD	(WRTK),A
 	LD	(WRTK+1),BC
 	LD	A,E
 	CALL	ASCII
 	LD	(WRSC),A
 	LD	(WRSC+1),BC
 	LD	A,'0'
 	BIT	4,(IY+3)
 	JR	Z,CONTW
 	INC	A
 CONTW	LD	(WRSD),A
 	PUSH	HL
 	LD	HL,WRMSG
 	CALL	@DISPLY
 	POP	HL
 	POP	DE
 	POP	BC
 	CALL	@WRSEC
 WRCALL	EQU	$-2
 	CALL	NZ,BADWRT
 	JR	NZ,WRTLP
 	INC	H
 	INC	E
 	LD	A,E
 	CP	0
 WRTOP	EQU	$-1
 	JR	NZ,WRTLP
 	RET
 BADRD	LD	(ERNO),A
 	XOR	A
 	NOP
 	PUSH	HL
 	LD	HL,BADRMSG
 	JR	DOBAD
 BADWRT	LD	(ERNO),A
 	XOR	A
 	NOP
 	PUSH	HL
 	LD	HL,BADWMSG
 	JR	DOBAD
 BADCYL	LD	(ERNO),A
 	XOR	A
 	NOP
 	PUSH	HL
 	LD	HL,BADCMSG
 DOBAD	PUSH	DE
 	PUSH	BC
 	LD	A,(ERNO)
 	CP	6
 	JR	Z,BADRET
 	CP	7
 	JR	Z,BADRET
 	CALL	@DISPLY
 	LD	A,(DRIVE)
 	OR	A
 	JR	Z,GETBAD
 	LD	A,0
 ERNO	EQU	$-1
 	OR	0C0H
 	CALL	@ERROR
 GETBAD	LD	HL,ASKBAD
 	CALL	@DISPLY
 	LD	B,1
 	LD	HL,STRING
 	CALL	@KEYIN
 	JP	C,TERMIN
 	LD	A,(HL)
 	CALL	UCASE
 	CP	'S'
 	JR	Z,BADRET
 	CP	'R'
 	JR	NZ,GETBAD
 	OR	1
 BADRET	POP	BC
 	POP	DE
 	POP	HL
 	RET
 ASCII	PUSH	HL
 	CALL	ASCI
 	LD	H,B
 	PUSH	HL
 	LD	A,C
 	SUB	30H
 	CALL	ASCI
 	LD	A,C
 	CP	'0'
 	JR	NZ,ASCIGO1
 	LD	A,20H
 ASCIGO1	POP	HL
 	LD	C,B
 	LD	B,H
 	POP	HL
 	RET
 ASCI	LD	C,'0'
 ASCII1	SUB	10
 	JR	C,ASCII2
 	INC	C
 	JR	ASCII1
 ASCII2	ADD	A,3AH
 	LD	B,A
 	RET
 UCASE	CP	60H
 	RET	C
 	CP	80H
 	RET	NC
 	AND	5FH
 	RET
 BUILD	LD	HL,ORDER
 	LD	BC,0E5E5H
 	BIT	6,(IY+3)
 	JR	Z,GOTORD
 	LD	HL,DORDER
 	LD	BC,0B66DH
 GOTORD	LD	(PATTUSE),BC
 	LD	C,(HL)
 	INC	HL
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)
 	INC	HL
 	CALL	ORDNEW
 	PUSH	DE
 	LD	DE,(FMTBUFF)
 	EX	DE,HL
 	CALL	MOVEIN
 	LD	(DESVE),DE
 SECLP	CALL	MOVEIN
 	CALL	MOVEIN
 	LD	(HL),0FEH
 	INC	HL
 	LD	A,(TRACK)
 	LD	(HL),A
 	INC	HL
 	LD	A,0
 SIDE	EQU	$-1
 	LD	(HL),A
 	INC	HL
 	EX	(SP),HL
 	LD	A,(HL)
 	INC	HL
 	EX	(SP),HL
 	LD	(HL),A
 	INC	HL
 	LD	(HL),1
 	INC	HL
 	LD	(HL),0F7H
 	INC	HL
 	CALL	MOVEIN
 	CALL	MOVEIN
 	CALL	MOVEIN
 	LD	(HL),0FBH
 	INC	HL
 	PUSH	DE
 	LD	E,128
 	PUSH	BC
 	LD	BC,0
 PATTUSE	EQU	$-2
 PATTLP	LD	(HL),C
 	INC	HL
 	LD	(HL),B
 	INC	HL
 	DEC	E
 	JR	NZ,PATTLP
 	POP	BC
 	POP	DE
 	LD	(HL),0F7H
 	INC	HL
 	CALL	MOVEIN
 	LD	DE,0
 DESVE	EQU	$-2
 	DEC	C
 	JR	NZ,SECLP
 	INC	SP
 	INC	SP
 	DEC	DE
 	LD	A,(DE)
 	JP	FILL
 MOVEIN	LD	A,(DE)
 	INC	DE
 	LD	B,A
 	LD	A,(DE)
 	INC	DE
 FILL	LD	(HL),A
 	INC	HL
 	DJNZ	FILL
 	RET
 ORDER	DB	10
 	DW	ORDERS
 	DB	1FH,0FFH
 	DB	3,0
 	DB	3,0
 	DB	0BH,0FFH
 	DB	3,0
 	DB	3,0
 	DB	0BH,0FFH
 DORDER	DB	18
 	DW	ORDERD
 	DB	3EH,4EH
 	DB	0CH,0
 	DB	3,0F5H
 	DB	16H,4EH
 	DB	0CH,0
 	DB	3,0F5H
 	DB	16H,4EH
 ORDERS	DB	0,5,1,6,2,7,3,8,4,9
 ORDERD	DB	0,6,12,1,7,13,2,8,14
 	DB	3,9,15,4,10,16,5,11,17
 ORDNEW	PUSH	BC
 	PUSH	DE
 	PUSH	HL
 	EX	DE,HL
 	LD	B,4
 	DEC	C
 ORDNEW1	PUSH	BC
 	LD	A,(HL)
 	PUSH	HL
 	INC	HL
 ORDNEW2	LD	E,(HL)
 	LD	(HL),A
 	LD	A,E
 	INC	HL
 	DEC	C
 	JR	NZ,ORDNEW2
 	POP	HL
 	LD	(HL),A
 	POP	BC
 	DJNZ	ORDNEW1
 	POP	HL
 	POP	DE
 	POP	BC
 	RET
 COMPDATA
 	LD	A,(IY+7)
 	AND	1FH
 	INC	A
 	BIT	5,(IY+4)
 	JR	Z,CONTCMP
 	SLA	A
 CONTCMP	LD	(RDTOP),A
 	LD	(WRTOP),A
 	LD	B,A
 	LD	C,0
 	LD	HL,@BUFFER
 	ADD	HL,BC
 	PUSH	HL
 	LD	HL,0
 	LD	(FMTBUFF),HL
 	CALL	BUILD
 	POP	DE
 	ADD	HL,DE		;HL = memory needed
 	LD	A,H
 	LD	DE,@BUFFER
 	CP	D
 	RET	C
 	LD	A,(4)
 	CP	30H
 	LD	DE,(4411H)
 	JR	Z,GOTTOP
 	LD	DE,(4049H)
 GOTTOP	OR	A
 	SBC	HL,DE
 	CCF
 	RET
 DESMOUNT
 	LD	HL,DMTMSG
 	JR	SYSMOUNT+3
 SYSMOUNT
 	LD	HL,SMTMSG
 	LD	A,(DRIVE)
 	OR	A
 	RET	NZ
 	PUSH	HL
 	PUSH	IY
 	LD	A,10
 	CALL	@DSP
 	POP	IY
 	POP	HL
 	EXX
 	LD	HL,CLRLIN
 	EXX
 	LD	BC,200H
 SYSLP	CALL	@DISPLY
 	PUSH	BC
 	CALL	@KBD
 	POP	BC
 	CP	13
 	JR	Z,MNTDON
 	DEC	BC
 	LD	A,B
 	OR	A
 	JR	NZ,SYSLP+3
 	EXX
 	JR	SYSLP-3
 MNTDON	PUSH	IY
 	LD	A,10
 	CALL	@DSP
 	POP	IY
 	RET
 SPDTBL	DB	'0','6'
 	DB	'1','2'
 	DB	'2','0'
 	DB	'4','0'
 ;##
 UPDMSG	DB	10,'Read Protecting Directory.',13
 CLRLIN	DB	1DH,1EH,3
 SMTMSG	DB	'Mount SYSTEM Disk.',3
 DMTMSG	DB	'Mount TARGET Disk.',3
 NOTMEM	DB	10,'Insufficient Memory Available !',13
 ASKBAD	DB	'R>etry, S>kip, or <BREAK> ? ',3
 BADRMSG	DB	10,'Disk READ Error !',13
 BADWMSG	DB	10,'Disk WRITE Error !',13
 BADCMSG	DB	10,'Disk FORMATTING Error !',13
 RDMSG	DB	1DH,'Reading    Cylinder'
 RDTK	DB	'xxx, Side '
 RDSD	DB	'x, Sector'
 RDSC	DB	'xxx.',3
 WRMSG	DB	1DH,'Writing    Cylinder'
 WRTK	DB	'xxx, Side '
 WRSD	DB	'x, Sector'
 WRSC	DB	'xxx.',3
 FMMSG	DB	1DH,'Formatting Cylinder'
 FMTK	DB	'xxx, Side '
 FMSD	DB	'x.',1EH,3
 FINMSG	DB	10,'* Re-Format Completed *',13
 ABMSG	DB	'* Aborted *',13
 PAUMSG	DB	'Pause on faulty sectors ? ',3
 MX0	DB	':'
 MX1	DB	'x   '
 MX2	DB	'x" Floppy #'
 MX2B	DB	'x, Cyls='
 MX3	DB	'xxx, '
 MX4	DB	'xDen, Sides='
 MX5	DB	'x, Step='
 MX5B	DB	'xxms, Dly='
 MX5C	DB	'xxs',13
 HARDMSG	DB	10,'Cannot re-format Hard Drives.',13
 MSG8	DB	10,'Cannot re-format 8" Drives.',13
 PARMSG	DB	'Parameter Error !',13
 HELLO	DB	1CH,1FH
 	DB	'PFORM - POWER Disk Re-Formatter Utility - Version 1.0',10
 	DB	'written specially for the LDOS Disk Operating System',10
 	DB	'by Kim Watt - (c)(p) 1982 Breeze/QSD, Inc.',10,10,13
 DRVMSG	DB	'Drive # to be re-formatted (0-7) ? ',3
 STRING	EQU	$&0FF00H
 @BUFFER	EQU	STRING+100H
 	ORG	@BUFFER
 WHO	DB	'* * * * * * * * * * * *',10
 	DB	'* Program by Kim Watt *',10
 	DB	'*     (c)(p) 1982     *',10
 	DB	'*   Breeze/QSD, Inc.  *',10
 	DB	'* 11500 Stemmons Fwy. *',10
 	DB	'*      Suite 125      *',10
 	DB	'* Dallas, Texas 75229 *',10
 	DB	'*   (214) 484-9428    *',10
 	DB	'* * * * * * * * * * * *',13
 	END	ENTRY
